LoyalistSpecialBehaviours = {};

function LoyalistSpecialBehaviours.moraleSystem(self)		--Right now only the flag can give morale to whomever wields it. More stuff soon:tm:


	self.morale = self.origMorale + self.flagBearerMorale + self.flagMorale + self.officerMorale + self.commissarMorale + self.tankMorale + self.carMorale + self.flareMorale

--[[
	if self.PresetName == "Loyalist" then
		print(self.morale)
		print(self:GetLimbPathSpeed(1))
	end
--]]
--	self:SetNumberValue("Morale Value",	self.morale)	--Afects guns

	if self.morale > 0 then

		self.Perceptiveness = self.origPerceptiveness + self.moralePerceptivnessMultiplier * self.morale
		self:SetLimbPathSpeed(1, (self.normalPath + self.pathSpeedMultiplier*self.morale))
	
		if self.IsPlayer == true and self.HUDVisible == true then
			local ctrl = self:GetController();
			local screen = ActivityMan:GetActivity():ScreenOfPlayer(ctrl.Player);	
					
			local flaggerIcon = CreateMOSRotating("Loyalists Morale HUD Icon", "Loyalists.rte");
			local flaggerIconPos = self.AboveHUDPos + Vector(0,-5) --self.Pos + Vector(28, -43)
						
			PrimitiveMan:DrawBitmapPrimitive(screen, flaggerIconPos, flaggerIcon, 3.14, self.morale - 1, true, true);
		end
	
	else	
		self.Perceptiveness = self.origPerceptiveness	
		self:SetLimbPathSpeed(1, (self.normalPath))

	end
	
	----------------------------- Objects and stuff that give morale --------------------------------------------

	if self:NumberValueExists("Flag Bearer Morale") then			
		if self:GetNumberValue("Flag Bearer Morale") > 0 then
			self.flagBearerMorale = 1
			if self.flagBearerMoraleTimer:IsPastSimMS(self.flagBearerMoraleDelay) then
				self.flagBearerMoraleTimer:Reset()
				self:SetNumberValue("Flag Bearer Morale", (self:GetNumberValue("Flag Bearer Morale") - 1))
			end
		elseif self:GetNumberValue("Flag Bearer Morale") == 0 then
			self.flagBearerMorale = 0
		end
	else
		self.flagBearerMorale = 0
	end
	
	if self:NumberValueExists("Flag Morale") then			
		if self:GetNumberValue("Flag Morale") > 0 then
			self.flagMorale = 1
			if self.flagMoraleTimer:IsPastSimMS(self.flagMoraleDelay) then
				self.flagMoraleTimer:Reset()
				self:SetNumberValue("Flag Morale", (self:GetNumberValue("Flag Morale") - 1))
			end
		elseif self:GetNumberValue("Flag Morale") == 0 then
			self.flagMorale = 0
		end
	else
		self.flagMorale = 0
	end	

	if self:NumberValueExists("Officer Morale") then			
		if self:GetNumberValue("Officer Morale") > 0 then
			self.officerMorale = 1
			if self.officerMoraleTimer:IsPastSimMS(self.officerMoraleDelay) then
				self.officerMoraleTimer:Reset()
				self:SetNumberValue("Officer Morale", (self:GetNumberValue("Officer Morale") - 1))
			end
		elseif self:GetNumberValue("Officer Morale") == 0 then
			self.officerMorale = 0
		end
	else
		self.officerMorale = 0
	end

	----Commisssar, flare, and tank = 2 points

	if self:NumberValueExists("Commissar Morale") then			
		if self:GetNumberValue("Commissar Morale") > 0 then
			self.commissarMorale = 2
			if self.commissarMoraleTimer:IsPastSimMS(self.commissarMoraleDelay) then
				self.commissarMoraleTimer:Reset()
				self:SetNumberValue("Commissar Morale", (self:GetNumberValue("Commissar Morale") - 1))
			end
		elseif self:GetNumberValue("Commissar Morale") == 0 then
			self.commissarMorale = 0
		end
	else
		self.commissarMorale = 0
	end

	if self:NumberValueExists("Tank Morale") then			
		if self:GetNumberValue("Tank Morale") > 0 then
			self.tankMorale = 2
			if self.tankMoraleTimer:IsPastSimMS(self.tankMoraleDelay) then
				self.tankMoraleTimer:Reset()
				self:SetNumberValue("Tank Morale", (self:GetNumberValue("Tank Morale") - 1))
			end
		elseif self:GetNumberValue("Tank Morale") == 0 then
			self.tankMorale = 0
		end
	else
		self.tankMorale = 0
	end
	
	if self:NumberValueExists("Car Morale") then			
		if self:GetNumberValue("Car Morale") > 0 then
			self.carMorale = 1
			if self.carMoraleTimer:IsPastSimMS(self.carMoraleDelay) then
				self.carMoraleTimer:Reset()
				self:SetNumberValue("Car Morale", (self:GetNumberValue("Car Morale") - 1))
			end
		elseif self:GetNumberValue("Car Morale") == 0 then
			self.carMorale = 0
		end
	else
		self.carMorale = 0
	end

	if self:NumberValueExists("Flare Morale") then
		if self:GetNumberValue("Flare Morale") > 0 then
			self.flareMorale = 2
			if self.flareMoraleTimer:IsPastSimMS(self.flareMoraleDelay) then
				self.flareMoraleTimer:Reset()
				self:SetNumberValue("Flare Morale", (self:GetNumberValue("Flare Morale") - 1))
			end
		elseif self:GetNumberValue("Flare Morale") == 0 then
			self.flareMorale = 0
		end
	else
		self.flareMorale = 0
	end

end

function LoyalistSpecialBehaviours.officerMorale(self)

	if self.officerMoraleTargetsTimer:IsPastSimMS(self.officerMoraleTargetsDelay) then
		self.officerMoraleTargetsTimer:Reset();
		for i = 1, #self.officerMoraleTargets do
			local testMoraleTarget = self.officerMoraleTargets[i];
			if testMoraleTarget and IsActor(testMoraleTarget) then
				testMoraleTarget:SetNumberValue("Officer Morale", 2)
			end
		end

		self.officerMoraleTargets = {};

		for act in MovableMan.Actors do
			if act.Team == self.Team and act.UniqueID ~= self.UniqueID and (act.PresetName == "Loyalist" or act.PresetName == "Fanatic" or act.PresetName == "Zealot" or act.PresetName == "Loyal Pilot" or act.PresetName == "Loyal Tanker") then
				local trace = SceneMan:ShortestDistance(self.Pos, act.Pos, false);
				if (trace.Magnitude - act.Radius) < self.officerMaxMoraleRange then
					local strSumCheck = SceneMan:CastStrengthSumRay(self.Pos, self.Pos + trace, 3, rte.airID);
					if strSumCheck < 10 then
						table.insert(self.officerMoraleTargets, act);
					end
				end
			end
		end
	end			
end

function LoyalistSpecialBehaviours.commissarMorale(self)

	if self.commissarMoraleTargetsTimer:IsPastSimMS(self.commissarMoraleTargetsDelay) then
		self.commissarMoraleTargetsTimer:Reset();
		for i = 1, #self.commissarMoraleTargets do
			local testMoraleTarget = self.commissarMoraleTargets[i];
			if testMoraleTarget and IsActor(testMoraleTarget) then
				testMoraleTarget:SetNumberValue("Commissar Morale", 2)
			end
		end

		self.commissarMoraleTargets = {};

		for act in MovableMan.Actors do
			if act.Team == self.Team and act.UniqueID ~= self.UniqueID and (act.PresetName == "Loyalist" or act.PresetName == "Fanatic" or act.PresetName == "Zealot" or act.PresetName == "Loyal Officer" or act.PresetName == "Loyal Pilot" or act.PresetName == "Loyal Tanker") then
				local trace = SceneMan:ShortestDistance(self.Pos, act.Pos, false);
				if (trace.Magnitude - act.Radius) < self.commissarMaxMoraleRange then
					local strSumCheck = SceneMan:CastStrengthSumRay(self.Pos, self.Pos + trace, 3, rte.airID);
					if strSumCheck < 10 then
						table.insert(self.commissarMoraleTargets, act);
					end
				end
			end
		end
	end		
end

function LoyalistSpecialBehaviours.offhandFixer(self)

	if not self.EquippedItem and self.EquippedBGItem and self.EquippedBGItem:HasObjectInGroup("Weapons - Secondary") and self.FGArm then
		local bgItem = self.EquippedBGItem.PresetName
		self:UnequipBGArm()
		self:EquipNamedDevice(bgItem, true)
	end

end

function LoyalistSpecialBehaviours.commissarSaber(self)

	if self.gotMelee == false then
		self.gotMelee = true
		self:AddInventoryItem(CreateHDFirearm("Saber", "Loyalists.rte"))
	end

end

function LoyalistSpecialBehaviours.meleeWeapon(self)	--Give melee weapont to enemy actors

	if self.PresetName == "Loyalist" then
		self.meleeWeaponChance = 0.75
		self.bluntChance = 0.5
		self.handToolChance = 0.15
	elseif self.PresetName == "Fanatic" then	--Will always have a melee weapon with him
		self.meleeWeaponChance = 1
		self.bluntChance = 0.8
		self.handToolChance = 0.4
	elseif self.PresetName == "Zealot" then		--If melee, Will always get a club unless he gets a hatchet
		self.meleeWeaponChance = 0.6
		self.bluntChance = 1
		self.handToolChance = 0.4
	elseif self.PresetName == "Loyal Officer" then		--Will always get a knoife
		self.meleeWeaponChance = 1
		self.bluntChance = 0
		self.handToolChance = 0
	end

	if self:HasObject("Knife") or self:HasObject("Club") or self:HasObject("Spiked Club") or self:HasObject("Spade") or self:HasObject("Hatchet") or self:HasObject("PickAxe") then
		self.gotMelee = true;		--We already have a melee weapon. Don't give us another one
	end
	------------- Probability of Armor Upgrade -------------------
	if self.gotMelee == false then
		local chance = 0

		if math.random() <= self.meleeWeaponChance then
			if math.random() <= self.handToolChance then
				chance = math.random(1,30)
				
				if chance >= 1 and chance <= 15 then
					self:AddInventoryItem(CreateHDFirearm("Spade", "Loyalists.rte"))
						
					local founds = ActivityMan:GetActivity():GetTeamFunds(self.Team);	--Remove gold
					ActivityMan:GetActivity():SetTeamFunds(founds - 4, self.Team);
				elseif chance > 15 and chance <= 25 then
					self:AddInventoryItem(CreateHDFirearm("Hatchet", "Loyalists.rte"))
						
					local founds = ActivityMan:GetActivity():GetTeamFunds(self.Team);	--Remove gold
					ActivityMan:GetActivity():SetTeamFunds(founds - 5, self.Team);				
				elseif chance > 25 and chance <= 30 then
					self:AddInventoryItem(CreateHDFirearm("PickAxe", "Loyalists.rte"))
						
					local founds = ActivityMan:GetActivity():GetTeamFunds(self.Team);	--Remove gold
					ActivityMan:GetActivity():SetTeamFunds(founds - 8, self.Team);			
				end
				self.gotMelee = true
			else
				if math.random() <= self.bluntChance then
					chance = math.random(1,30)
					if chance >= 1 and chance <= 20 then
						self:AddInventoryItem(CreateHDFirearm("Club", "Loyalists.rte"))
							
						local founds = ActivityMan:GetActivity():GetTeamFunds(self.Team);	--Remove gold
						ActivityMan:GetActivity():SetTeamFunds(founds - 2, self.Team);
					elseif chance > 20 and chance <= 30 then
						self:AddInventoryItem(CreateHDFirearm("Spiked Club", "Loyalists.rte"))
							
						local founds = ActivityMan:GetActivity():GetTeamFunds(self.Team);	--Remove gold
						ActivityMan:GetActivity():SetTeamFunds(founds - 3, self.Team);
					end
					self.gotMelee = true
				else
					self:AddInventoryItem(CreateHDFirearm("Knife", "Loyalists.rte"))
						
					local founds = ActivityMan:GetActivity():GetTeamFunds(self.Team);	--Remove gold
					ActivityMan:GetActivity():SetTeamFunds(founds - 1, self.Team);
					
					self.gotMelee = true
				end
			end
		end
	end
end

function LoyalistSpecialBehaviours.extraGear(self)	--Give melee weapont to enemy actors

	if self.PresetName == "Loyalist" then
		self.gearBandageChance = 0.2
		self.gearFlarePistolChance = 0
	elseif self.PresetName == "Fanatic" then
		self.gearBandageChance = 0.35
		self.gearFlarePistolChance = 0
	elseif self.PresetName == "Zealot" then	
		self.gearBandageChance = 0.1
		self.gearFlarePistolChance = 0
	elseif self.PresetName == "Loyal Officer" then
		self.gearBandageChance = 0.25
		self.gearFlarePistolChance = 0.35
	elseif self.PresetName == "Loyal Commissar" then
		self.gearBandageChance = 0
		self.gearFlarePistolChance = 0.15
	end

	if math.random() <= self.gearBandageChance then
		self:AddInventoryItem(CreateHDFirearm("Bandages", "Loyalists.rte"))
			
		local founds = ActivityMan:GetActivity():GetTeamFunds(self.Team);	--Remove gold
		ActivityMan:GetActivity():SetTeamFunds(founds - 10, self.Team);
	end

	if math.random() <= self.gearBandageChance then
		self:AddInventoryItem(CreateHDFirearm("Bandages", "Loyalists.rte"))
			
		local founds = ActivityMan:GetActivity():GetTeamFunds(self.Team);	--Remove gold
		ActivityMan:GetActivity():SetTeamFunds(founds - 10, self.Team);
	end
	
	if math.random() <= self.gearFlarePistolChance then
		self:AddInventoryItem(CreateHDFirearm("Flare Gun", "Loyalists.rte"))
			
		local founds = ActivityMan:GetActivity():GetTeamFunds(self.Team);	--Remove gold
		ActivityMan:GetActivity():SetTeamFunds(founds - 40, self.Team);
	end

end
