dofile("Base.rte/Constants.lua")
package.path = package.path .. ";Loyalists.rte/?.lua";
require("Actors/Vehicles/AI/NativeLoyalistVehicleAI")
require("Actors/Vehicles/AI/LoyalistVehicleSpecialBehaviours")

function Create(self)
	self.AI = NativeLoyalistVehicleAI:Create(self)

	self.tankMoraleTargetsTimer = Timer();
	self.tankMoraleTargetsDelay = 500
	self.tankMoraleTargets = {};
	self.tankMaxMoraleRange = 220 + self.Radius
	
	self.carMoraleTargetsTimer = Timer();
	self.carMoraleTargetsDelay = 400
	self.carMoraleTargets = {};
	self.carMaxMoraleRange = 180 + self.Radius

end

function Update(self)

	if (not self:IsDead()) then
	
		if self.PresetName == "Loyalist Tank" then
			LoyalistVehicleSpecialBehaviours.tankMorale(self)
		elseif self.PresetName == "Loyalist Armored Car" then
			LoyalistVehicleSpecialBehaviours.carMorale(self)
		end
		
	end

end

function UpdateAI(self)
	self.AI:Update(self)
end

function Destroy(self)
	self.AI:Destroy(self)
end
