function Create(self)

	self.orgStance = Vector(-3,4)--self.StanceOffset
	self.stabStance = Vector(5,2)
	
	self.orgSupport = Vector(2,0)
	self.stabSupport = Vector(1,1)

	self.parent = nil
	
	self.whatTeam = 69
	self.lunge = true;
	
	self.armed = false

	self.Frame = 0
	
	self.pin = false

end

function Update(self)

	if self:IsAttached() == true then 		--I think this is more performance friendly as it doesn't check the parent every frame, rather just when the gun is first taken.
		if self.parent == nil then
			if IsAHuman(self:GetRootParent()) then
				self.parent = ToAHuman(self:GetRootParent())
			end
		end
	else
		self.parent = nil;
	end

	if self.parent then
	
		self.whatTeam = self.parent.Team
		self.parent:GetController():SetState(Controller.AIM_SHARP,false);
		
		if self:IsActivated() then
			self.StanceOffset = self.stabStance
			self.SupportOffset = self.stabSupport
			if self.lunge == true then
				local aimAngle = self.parent:GetAimAngle(false)
				self.parent.Vel = self.parent.Vel + Vector(0.5*self.FlipFactor,-0.5):RadRotate(aimAngle*0.65*self.FlipFactor)
				self.lunge = false;
			end
		else
			self.StanceOffset = self.orgStance
			self.SupportOffset = self.orgSupport
			self.lunge = true;
		end
	else
		self.whatTeam = 69
	end

	if self:IsActivated() then
		self.armed = true

		if self.pin == false then

			self.pin = true
			
			pin = CreateMOSParticle("Loyalists Lunge Mine Pin", "Loyalists.rte");
			pin.Pos = self.Pos;
			pin.Vel = self.Vel+Vector(0,-6)+Vector(3*math.random(),0):RadRotate(math.random()*(math.pi*2));
			MovableMan:AddParticle(pin);

			sfx = CreateAEmitter("Loyalists Pin Pulled Sound", "Loyalists.rte");
			sfx.Pos = self.Pos;
			MovableMan:AddParticle(sfx);		
		end
	end

	if self.armed == true then
		self.Frame = 1
	
		local checkPosUp = self.Pos + Vector(17*self.FlipFactor,-2):RadRotate(self.RotAngle);
		local checkPosMiddle = self.Pos + Vector(17*self.FlipFactor,0):RadRotate(self.RotAngle);
		local checkPosDown = self.Pos + Vector(17*self.FlipFactor,2):RadRotate(self.RotAngle);
		
		local checkTable = {checkPosMiddle, checkPosUp, checkPosDown}
	
		for i = 1, 3 do				--Raycast, to activate and hopefully avoid bouncing projectiles
			local checkPos = checkTable[i]
			if SceneMan.SceneWrapsX == true then
				if checkPos.X > SceneMan.SceneWidth then
					checkPos = Vector(checkPos.X - SceneMan.SceneWidth,checkPos.Y);
				elseif checkPos.X < 0 then
					checkPos = Vector(SceneMan.SceneWidth + checkPos.X,checkPos.Y);
				end
			end
			local terrCheck = SceneMan:GetTerrMatter(checkPos.X,checkPos.Y);
			if terrCheck == 0 then
				local moCheck = SceneMan:GetMOIDPixel(checkPos.X,checkPos.Y);
				if moCheck ~= 255 then
					local actor = MovableMan:GetMOFromID( MovableMan:GetMOFromID(moCheck).RootID );
					if actor.Team ~= self.whatTeam then
						self:GibThis();
					end
				end
			else
				self:GibThis();
			end
		end
	end
end
