--[[
######################################################################
##  File:	Crate.lua												##
##  Author:	'OliveD' (olived@live.ca)								##
##	Notes:	Explodes when it hits the ground, without transfering	##
##			it's velocity to the contents. Both this and Chute.lua	##
##			contain part of NoCasualty.lua by Data Realms.			##
######################################################################
]]--

function Create(self)

	self.Pos = self.Pos + Vector(math.random(-50,50),0)

	self.dropTimer = Timer();
	self.destroyThis = 0;
end

function Update(self)

	if self.destroyThis == 1 then
		self.dropTimer:Reset();
		self.destroyThis = 2;
	end

	if self.destroyThis == 2 and self.dropTimer:IsPastSimMS(100) then
		self:GibThis();
		self.destroyThis=3;
	end
end

function Destroy(self)
	ActivityMan:GetActivity():ReportDeath(self.Team,-1);
end

function OnCollideWithTerrain(self, terrainID)

	if self.destroyThis == 0 then
		self.destroyThis = 1
	end

end
