function Create(self)
	--Animation stuff--

	self.Frame = 0;

	if self.Magazine then
		self.ammoCount = self.Magazine.RoundCount;
	end

	self.ejectedShell = false;
	self.firedShells = 0;
	
	--------------------------------------------

	self.hasBroken = false;
	self.chanceToBreak = 0.5
	self.chanceToBreakIncrease = 0.2
	
	self.dropEmpty = false;

	self.toDropPlayerTimer = Timer()
	self.toDropPlayerDelay = 100

	self.toDropTimer = Timer()
	self.toDropDelay = 650

	self.toSettleDelay = 3000
	self.toSettleDelayFinal = 8000

end

function Update(self)

	if self.hasBroken == false then
		if self.Magazine ~= nil then
			self.ejectedShell = false;
		else
			if self.ejectedShell == false then
				self.ejectedShell = true;
	--			for i = 1, self.firedShells do
	--				local primer = CreateAEmitter("Fired Primer", "Loyalists.rte");
	--				primer.Pos = self.Pos;
	--				primer.Vel = Vector(math.random()*(-3)*self.FlipFactor,0):RadRotate(self.RotAngle):DegRotate((math.random()*32)-16);
	--				MovableMan:AddParticle(primer);
	--			end
				self.firedShells = 0
			end
		end
		
		if self.FiredFrame then
			self.firedShells = self.firedShells + 1;
		end		
		
		if self.Magazine then
			self.Frame = 0;
		else
			self.Frame = 1;
		end
	end

	if self:IsAttached() == true then 		--I think this is more performance friendly as it doesn't check the parent every frame, rather just when the gun is first taken.
		if self.parent == nil then
			local actor = MovableMan:GetMOFromID(self.RootID);
			if actor and IsAHuman(actor) then
				self.parent = ToAHuman(actor);
			end
		end
	else
		self.parent = nil;
	end

	if self.FiredFrame then
		if math.random() < self.chanceToBreak then
			self.hasBroken = true;
			self.Reloadable = false;
		else
			self.chanceToBreak = self.chanceToBreak + self.chanceToBreakIncrease
		end
		
		self.toDropTimer:Reset()
		self.toDropPlayerTimer:Reset()		
	end
	
	if self.hasBroken == true then
		self.Frame = 2

		self:Deactivate()

		if self.parent then
			self.parent:GetController():SetState(Controller.WEAPON_RELOAD,false);
			
			if self.parent:GetController():IsState(Controller.WEAPON_FIRE) == true then
				if self.toDropPlayerTimer:IsPastSimMS(self.toDropPlayerDelay) then
					self.GetsHitByMOs = false;
					self.dropEmpty = true;
					if self:IsAttached() then
						self:RemoveFromParent(true,true)
					end
				else
					self.toDropPlayerTimer:Reset()
				end
			end
		end

		if self.Magazine then
			self.Magazine.RoundCount = 0
		end

		self.HUDVisible = false;

		if self.toDropTimer:IsPastSimMS(self.toDropDelay) --[[In the case we are reloading for some dumb reason]] then
			self.GetsHitByMOs = false;
			self.dropEmpty = true;
			if self:IsAttached() then
				self:RemoveFromParent(true,true)
			end
		end
		
		if self.toDropTimer:IsPastSimMS(self.toSettleDelay) then
			if self.Vel.Magnitude < 0.15 then
				self.ToSettle = true;
			end
		end
		
		if self.toDropTimer:IsPastSimMS(self.toSettleDelayFinal) then
			self.ToSettle = true;
		end

	end
end

function OnDetach(self)

	if self.dropEmpty == true then
		self.Vel = self.Vel + Vector(math.random(2,5)*self.FlipFactor, -1):RadRotate(self.RotAngle -0.5)
	end

end